---
title: Screen Wake Lock API
slug: Web/API/Screen_Wake_Lock_API
tags:
  - API
  - Overview
  - Reference
  - Screen Wake Lock API
  - Wake Lock
  - WakeLock
  - screen
---
<p>{{DefaultAPISidebar("Screen Wake Lock API")}}</p>

<p class="summary">The Screen Wake Lock API provides a way to prevent devices from dimming or locking the screen when an application needs to keep running.</p>

<h2 id="Concepts_and_Usage">Concepts and Usage</h2>

<p>Most devices by default turn off their screen after a specified amount of time to prolong the life of the hardware. Modern devices do this to save on battery power. Whilst this is a useful feature, some applications need the screen to stay awake to be their most useful.</p>

<p>The Screen Wake Lock API prevents the screen from turning off, dimming or locking. It allows for a simple platform-based solution which up until now could only be achieved via workarounds which were potentially power hungry. Only visible (active) documents can acquire the screen wake lock.</p>

<p>There are plenty of use cases for keeping a screen on, including reading an ebook, map navigation, following a recipe, presenting to an audience, scanning a QR/barcode or applications that use voice or gesture control, rather than tactile input (the default way to keep a screen awake).</p>

<p>You acquire a {{DOMxRef("WakeLockSentinel")}} object by calling the {{domxref('WakeLock.request','navigator.wakeLock.request()')}} {{jsxref('Promise')}}-based method that resolves if the platform allows it. A request may be rejected for a number of reasons, including system settings (such as power save mode or low battery level) or if the document is not active or visible.</p>

<p>The sentinel is attached to the underlying system wake lock. It can be released by the system, again if the battery power is too low or the document is not active or visible. It can also be released manually via the {{domxref('WakeLockSentinel.release()')}} method. It is good practice to store a reference to the sentinel object to control release later and also to reacquire the lock if need be.</p>

<p>The Screen Wake Lock API should be used to keep the screen on to benefit usability. It's a good idea to show some feedback on the interface to show if wake lock is active and a way for the user to disable it if they wish.</p>

<h2 id="Screen_Wake_Lock_API_Interfaces">Screen Wake Lock API Interfaces</h2>

<dl>
 <dt>{{domxref("WakeLock")}}</dt>
 <dd>The <strong><code>WakeLock</code></strong> interface prevents device screens from dimming or locking when an application needs to keep running.</dd>
 <dt>{{domxref("WakeLockSentinel")}}</dt>
 <dd>Provides a handle to the underlying platform wake lock and if referenced can be manually released and reacquired. Get an instance of the object by calling {{domxref('WakeLock.request')}}.</dd>
 <dt>{{domxref("Navigator.wakelock")}}</dt>
 <dd>Returns a {{domxref("WakeLock")}} object instance, from which all other functionality can be accessed.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Feature_Detection">Feature Detection</h3>

<p>This code checks for wake lock support and updates the UI accordingly.</p>

<pre class="brush: js notranslate">if ('wakeLock' in navigator) {
  isSupported = true;
  statusElem.textContent = 'Screen Wake Lock API supported!';
} else {
  wakeButton.disabled = true;
  statusElem.textContent = 'Wake lock is not supported by this browser.';
}
</pre>

<h3 id="Requesting_a_wake_lock">Requesting a wake lock</h3>

<p>The following example demonstrates how to request a {{domxref('WakeLockSentinel')}} object. The {{domxref('WakeLock.request')}} method is {{jsxref('Promise')}}-based and so we can create an asynchronous function, which in turn updates the UI to reflect the wake lock is active.</p>

<pre class="brush: js notranslate">// Create a reference for the Wake Lock.
let wakeLock = null;

// create an async function to request a wake lock
try {
  wakeLock = await navigator.wakeLock.request('screen');
  statusElem.textContent = 'Wake Lock is active!';
} catch (err) {
  // The Wake Lock request has failed - usually system related, such as battery.
  statusElem.textContent = `${err.name}, ${err.message}`;
}</pre>

<h3 id="Releasing_wake_lock">Releasing wake lock</h3>

<p>The following example shows how to release the previously acquired wake lock.</p>

<pre class="brush: js notranslate">wakeLock.release()
  .then(() =&gt; {
    wakeLock = null;
  });</pre>

<h3 id="Listening_for_wake_lock_release">Listening for wake lock release</h3>

<p>This example updates the UI if the wake lock has been released for any reason (such as navigating away from the active window/tab).</p>

<pre class="brush: js notranslate">wakeLock.addEventListener('release', () =&gt; {
  // the wake lock has been released
  statusElem.textContent = 'Wake Lock has been released';
});</pre>

<h3 id="Reacquiring_a_wake_lock">Reacquiring a wake lock</h3>

<p>The following code reacquires the wake lock should the visibility of the document change and the wake lock is released.</p>

<pre class="brush: js notranslate">document.addEventListener('visibilitychange', async () =&gt; {
  if (wakeLock !== null &amp;&amp; document.visibilityState === 'visible') {
    wakeLock = await navigator.wakeLock.request('screen');
  }
});</pre>

<h3 id="Putting_it_all_together">Putting it all together</h3>

<p>You can find the <a href="https://github.com/mdn/dom-examples/tree/master/screen-wake-lock-api">complete code on GitHub here</a>. The <a href="https://mdn.github.io/dom-examples/screen-wake-lock-api/">demo</a> uses a button to acquire a wake lock and also release it, which in turn updates the UI. The UI also updates if the wake lock is released automatically for any reason. There's a checkbox which when checked, will automatically reacquire the wake lock if the document's visibility state changes and becomes visible again.</p>

<h3 id="Performance_considerations">Performance considerations</h3>

<ul>
 <li>Release the screen wake lock when user ends activity that required always-on screen. For example, a ticketing app which uses QR codes to transmit ticket information, might acquire screen wake lock when the QR code is displayed (so that code is successfully scanned) but release afterwards. A presentation app might hold the lock only while a presentation is active, but not when presentation is being edited.</li>
 <li>If your app is performing long-running downloads, consider using background fetch.</li>
 <li>If you app is synchronizing data from a remote server, consider using background sync.</li>
 <li>Only active documents can acquire screen wake locks and previously acquired locks are automatically released when document becomes inactive. Therefore make sure to re-acquire screen wake lock if necessary when document becomes active (listen for <a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a> event).</li>
</ul>

<h2 id="Feature_Policy_integration">Feature Policy integration</h2>

<p>Access to Screen Wake Lock API is controlled by <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a> directive {{HTTPHeader("Feature-Policy/screen-wake-lock","screen-wake-lock")}}. Refer to <a href="/en-US/docs/Web/HTTP/Feature_Policy/Using_Feature_Policy">Using Feature Policy</a> for reference how to use it.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Screen Wake Lock')}}</td>
   <td>{{Spec2('Screen Wake Lock')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WakeLock")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://web.dev/wakelock/">An introductory article on the Screen Wake Lock API</a></li>
 <li><a href="https://wake-lock-demo.glitch.me/">A Screen Wake Lock API demo on glitch</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a> directive {{HTTPHeader("Feature-Policy/screen-wake-lock","screen-wake-lock")}}</li>
</ul>
</div>
